Module | Rack::Utils
In: | lib/action_controller/vendor/rack-1.0/rack/utils.rb

Rack::Utils contains a grab-bag of useful methods for writing web applications adopted from all kinds of Ruby libraries.

### Methods

build_query bytesize bytesize escape escape_html normalize_params parse_nested_query parse_query select_best_encoding unescape

### Classes and Modules

Module Rack::Utils::Multipart
Class Rack::Utils::Context
Class Rack::Utils::HeaderHash

### Constants

HTTP_STATUS_CODES | = | { 100 => 'Continue', 101 => 'Switching Protocols', 200 => 'OK', 201 => 'Created', 202 => 'Accepted', 203 => 'Non-Authoritative Information', 204 => 'No Content', 205 => 'Reset Content', 206 => 'Partial Content', 300 => 'Multiple Choices', 301 => 'Moved Permanently', 302 => 'Found', 303 => 'See Other', 304 => 'Not Modified', 305 => 'Use Proxy', 307 => 'Temporary Redirect', 400 => 'Bad Request', 401 => 'Unauthorized', 402 => 'Payment Required', 403 => 'Forbidden', 404 => 'Not Found', 405 => 'Method Not Allowed', 406 => 'Not Acceptable', 407 => 'Proxy Authentication Required', 408 => 'Request Timeout', 409 => 'Conflict', 410 => 'Gone', 411 => 'Length Required', 412 => 'Precondition Failed', 413 => 'Request Entity Too Large', 414 => 'Request-URI Too Large', 415 => 'Unsupported Media Type', 416 => 'Requested Range Not Satisfiable', 417 => 'Expectation Failed', 500 => 'Internal Server Error', 501 => 'Not Implemented', 502 => 'Bad Gateway', 503 => 'Service Unavailable', 504 => 'Gateway Timeout', 505 => 'HTTP Version Not Supported' |  | Every standard HTTP code mapped to the appropriate message. Stolen from Mongrel.
STATUS_WITH_NO_ENTITY_BODY | = | Set.new((100..199).to_a << 204 << 304) |  | Responses with HTTP status codes that should not have an entity body

### Public Instance methods

build_query(params)
bytesize(string)
bytesize(string)
escape(s)

Performs URI escaping so that you can construct proper query strings faster. Use this rather than the cgi.rb version since it‘s faster. (Stolen from Camping).

escape_html(string)

Escape ampersands, brackets and quotes to their HTML/XML entities.

normalize_params(params, name, v = nil)
parse_nested_query(qs, d = '&;')
parse_query(qs, d = '&;')

Stolen from Mongrel, with some small modifications: Parses a query string by breaking it up at the ’&’ and ’;’ characters. You can also use this to parse cookies by changing the characters used in the second parameter (which defaults to ’&;’).

select_best_encoding(available_encodings, accept_encoding)
unescape(s)

Unescapes a URI escaped string. (Stolen from Camping).

[Validate]